"use strict";
/*!
  Copyright 2018 Ron Buckton (rbuckton@chronicles.org)

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
 */
/**
 * @module "iterable-query/fn"
 * @preferred
 */
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
// queries
__export(require("./choose"));
__export(require("./chooseAsync"));
__export(require("./consume"));
__export(require("./consumeAsync"));
__export(require("./continuous"));
__export(require("./continuousAsync"));
__export(require("./empty"));
__export(require("./emptyAsync"));
__export(require("./generate"));
__export(require("./generateAsync"));
__export(require("./hierarchy"));
__export(require("./hierarchyAsync"));
__export(require("./if"));
__export(require("./ifAsync"));
__export(require("./conditional"));
__export(require("./conditionalAsync"));
__export(require("./objectKeys"));
__export(require("./objectKeysAsync"));
__export(require("./objectValues"));
__export(require("./objectValuesAsync"));
__export(require("./objectEntries"));
__export(require("./objectEntriesAsync"));
__export(require("./once"));
__export(require("./onceAsync"));
__export(require("./repeat"));
__export(require("./repeatAsync"));
__export(require("./range"));
// scalars
__export(require("./average"));
__export(require("./averageAsync"));
__export(require("./break"));
__export(require("./breakAsync"));
__export(require("./corresponds"));
__export(require("./correspondsAsync"));
__export(require("./count"));
__export(require("./countAsync"));
__export(require("./drain"));
__export(require("./drainAsync"));
__export(require("./elementAt"));
__export(require("./elementAtAsync"));
__export(require("./nth"));
__export(require("./nthAsync"));
__export(require("./endsWith"));
__export(require("./endsWithAsync"));
__export(require("./every"));
__export(require("./everyAsync"));
__export(require("./first"));
__export(require("./firstAsync"));
__export(require("./forEach"));
__export(require("./forEachAsync"));
__export(require("./includes"));
__export(require("./includesAsync"));
__export(require("./includesSequence"));
__export(require("./includesSequenceAsync"));
__export(require("./last"));
__export(require("./lastAsync"));
__export(require("./max"));
__export(require("./maxAsync"));
__export(require("./min"));
__export(require("./minAsync"));
__export(require("./reduce"));
__export(require("./reduceAsync"));
__export(require("./reduceRight"));
__export(require("./reduceRightAsync"));
__export(require("./single"));
__export(require("./singleAsync"));
__export(require("./some"));
__export(require("./someAsync"));
__export(require("./span"));
__export(require("./spanAsync"));
__export(require("./startsWith"));
__export(require("./startsWithAsync"));
__export(require("./sum"));
__export(require("./sumAsync"));
__export(require("./toArray"));
__export(require("./toArrayAsync"));
__export(require("./toMap"));
__export(require("./toMapAsync"));
__export(require("./toObject"));
__export(require("./toObjectAsync"));
__export(require("./toSet"));
__export(require("./toSetAsync"));
__export(require("./unzip"));
__export(require("./unzipAsync"));
// subqueries
__export(require("./append"));
__export(require("./appendAsync"));
__export(require("./concat"));
__export(require("./concatAsync"));
__export(require("./defaultIfEmpty"));
__export(require("./defaultIfEmptyAsync"));
__export(require("./distinct"));
__export(require("./distinctAsync"));
__export(require("./do"));
__export(require("./doAsync"));
__export(require("./tap"));
__export(require("./tapAsync"));
__export(require("./except"));
__export(require("./exceptAsync"));
__export(require("./relativeComplement"));
__export(require("./relativeComplementAsync"));
__export(require("./expand"));
__export(require("./expandAsync"));
__export(require("./eval"));
__export(require("./evalAsync"));
__export(require("./filter"));
__export(require("./filterAsync"));
__export(require("./filterDefined"));
__export(require("./filterDefinedAsync"));
__export(require("./where"));
__export(require("./whereAsync"));
__export(require("./whereDefined"));
__export(require("./whereDefinedAsync"));
__export(require("./intersect"));
__export(require("./intersectAsync"));
__export(require("./map"));
__export(require("./mapAsync"));
__export(require("./select"));
__export(require("./selectAsync"));
__export(require("./flatMap"));
__export(require("./flatMapAsync"));
__export(require("./selectMany"));
__export(require("./selectManyAsync"));
__export(require("./pageBy"));
__export(require("./pageByAsync"));
__export(require("./patch"));
__export(require("./patchAsync"));
__export(require("./prepend"));
__export(require("./prependAsync"));
__export(require("./reverse"));
__export(require("./reverseAsync"));
__export(require("./skip"));
__export(require("./skipAsync"));
__export(require("./skipRight"));
__export(require("./skipRightAsync"));
__export(require("./skipUntil"));
__export(require("./skipUntilAsync"));
__export(require("./skipWhile"));
__export(require("./skipWhileAsync"));
__export(require("./spanMap"));
__export(require("./spanMapAsync"));
__export(require("./groupBy"));
__export(require("./groupByAsync"));
__export(require("./groupJoin"));
__export(require("./groupJoinAsync"));
__export(require("./join"));
__export(require("./joinAsync"));
__export(require("./fullJoin"));
__export(require("./fullJoinAsync"));
__export(require("./scan"));
__export(require("./scanAsync"));
__export(require("./scanRight"));
__export(require("./scanRightAsync"));
__export(require("./symmetricDifference"));
__export(require("./symmetricDifferenceAsync"));
__export(require("./xor"));
__export(require("./xorAsync"));
__export(require("./take"));
__export(require("./takeAsync"));
__export(require("./takeRight"));
__export(require("./takeRightAsync"));
__export(require("./takeWhile"));
__export(require("./takeWhileAsync"));
__export(require("./takeUntil"));
__export(require("./takeUntilAsync"));
__export(require("./union"));
__export(require("./unionAsync"));
__export(require("./zip"));
__export(require("./zipAsync"));
__export(require("./through"));
__export(require("./throughAsync"));
__export(require("./toHierarchy"));
__export(require("./toHierarchyAsync"));
__export(require("./toLookup"));
__export(require("./toLookupAsync"));
__export(require("./orderBy"));
__export(require("./orderByAsync"));
// hierarchy
__export(require("./traversal"));
__export(require("./traversalAsync"));
__export(require("./nthChild"));
__export(require("./nthChildAsync"));
__export(require("./topMost"));
__export(require("./topMostAsync"));
__export(require("./bottomMost"));
__export(require("./bottomMostAsync"));
// utils
__export(require("./common"));
