"use strict";
/*!
  Copyright 2018 Ron Buckton (rbuckton@chronicles.org)

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
 */
/** @module "iterable-query/fn" */
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var internal_1 = require("../internal");
/**
 * Creates an [[Iterable]] that, when iterated, consumes the provided [[Iterator]].
 *
 * @param iterator An [[Iterator]] object.
 * @category Query
 */
function consume(iterator, options) {
    if (options === void 0) { options = {}; }
    var _a = options.cacheElements, cacheElements = _a === void 0 ? false : _a, _b = options.leaveOpen, leaveOpen = _b === void 0 ? false : _b;
    internal_1.assert.mustBeIterator(iterator, "iterator");
    internal_1.assert.mustBeBoolean(cacheElements, "cacheElements");
    return new ConsumeIterable(iterator, cacheElements, leaveOpen);
}
exports.consume = consume;
var ConsumeIterable = /** @class */ (function () {
    function ConsumeIterable(iterator, cacheElements, leaveOpen) {
        this._iterator = iterator;
        this._cache = cacheElements ? [] : undefined;
        this._leaveOpen = leaveOpen;
    }
    ConsumeIterable.prototype[Symbol.iterator] = function () {
        var offset, _a, done, value;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    offset = 0;
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, , 10, 11]);
                    _b.label = 2;
                case 2:
                    if (!(this._cache && offset < this._cache.length)) return [3 /*break*/, 4];
                    return [4 /*yield*/, this._cache[offset++]];
                case 3:
                    _b.sent();
                    return [3 /*break*/, 8];
                case 4:
                    if (!this._iterator) return [3 /*break*/, 7];
                    _a = this._iterator.next(), done = _a.done, value = _a.value;
                    if (!!done) return [3 /*break*/, 6];
                    if (this._cache)
                        this._cache.push(value);
                    return [4 /*yield*/, value];
                case 5:
                    _b.sent();
                    offset++;
                    return [3 /*break*/, 8];
                case 6:
                    this._iterator = undefined;
                    _b.label = 7;
                case 7: return [2 /*return*/];
                case 8: return [3 /*break*/, 2];
                case 9: return [3 /*break*/, 11];
                case 10:
                    if (!this._leaveOpen) {
                        internal_1.IteratorClose(this._iterator);
                    }
                    return [7 /*endfinally*/];
                case 11: return [2 /*return*/];
            }
        });
    };
    ConsumeIterable = __decorate([
        internal_1.ToStringTag("ConsumeIterable")
    ], ConsumeIterable);
    return ConsumeIterable;
}());
