"use strict";
/*!
  Copyright 2018 Ron Buckton (rbuckton@chronicles.org)

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
 */
/** @module "iterable-query/fn" */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var internal_1 = require("../internal");
function correspondsAsync(left, right, equalityComparison) {
    if (equalityComparison === void 0) { equalityComparison = internal_1.SameValue; }
    return __awaiter(this, void 0, void 0, function () {
        var _a, _b, leftIterator, leftDone, leftValue, rightIterator, rightDone, rightValue;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    internal_1.assert.mustBeAsyncQueryable(left, "left");
                    internal_1.assert.mustBeAsyncQueryable(right, "right");
                    internal_1.assert.mustBeFunction(equalityComparison, "equalityComparison");
                    leftIterator = internal_1.GetAsyncIterator(internal_1.ToPossiblyAsyncIterable(left));
                    leftDone = false;
                    _c.label = 1;
                case 1:
                    _c.trys.push([1, , 12, 15]);
                    rightIterator = internal_1.GetAsyncIterator(internal_1.ToPossiblyAsyncIterable(right));
                    rightDone = false;
                    rightValue = void 0;
                    _c.label = 2;
                case 2:
                    _c.trys.push([2, , 8, 11]);
                    _c.label = 3;
                case 3: return [4 /*yield*/, leftIterator.next()];
                case 4:
                    (_a = _c.sent(), leftDone = _a.done, leftValue = _a.value);
                    return [4 /*yield*/, rightIterator.next()];
                case 5:
                    (_b = _c.sent(), rightDone = _b.done, rightValue = _b.value);
                    if (leftDone && rightDone)
                        return [2 /*return*/, true];
                    if (Boolean(leftDone) !== Boolean(rightDone) || !equalityComparison(leftValue, rightValue))
                        return [2 /*return*/, false];
                    _c.label = 6;
                case 6: return [3 /*break*/, 3];
                case 7: return [3 /*break*/, 11];
                case 8:
                    if (!!rightDone) return [3 /*break*/, 10];
                    return [4 /*yield*/, internal_1.AsyncIteratorClose(rightIterator)];
                case 9:
                    _c.sent();
                    _c.label = 10;
                case 10: return [7 /*endfinally*/];
                case 11: return [3 /*break*/, 15];
                case 12:
                    if (!!leftDone) return [3 /*break*/, 14];
                    return [4 /*yield*/, internal_1.AsyncIteratorClose(leftIterator)];
                case 13:
                    _c.sent();
                    _c.label = 14;
                case 14: return [7 /*endfinally*/];
                case 15: return [2 /*return*/];
            }
        });
    });
}
exports.correspondsAsync = correspondsAsync;
