"use strict";
/*!
  Copyright 2018 Ron Buckton (rbuckton@chronicles.org)

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
 */
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var types_1 = require("../types");
var conversion_1 = require("./conversion");
var guards_1 = require("./guards");
var decorators_1 = require("./decorators");
var types_2 = require("./types");
var fn_1 = require("../fn");
/** @internal */
function GetIterator(source) {
    var iterator = source[Symbol.iterator];
    if (typeof iterator === "function") {
        return iterator.call(source);
    }
    throw new TypeError();
}
exports.GetIterator = GetIterator;
/** @internal */
function GetAsyncIterator(source) {
    var asyncIterator = guards_1.IsAsyncIterable(source) ? source[Symbol.asyncIterator] : undefined;
    if (typeof asyncIterator === "function") {
        return asyncIterator.call(source);
    }
    var iterator = guards_1.IsIterable(source) ? source[Symbol.iterator] : undefined;
    if (typeof iterator === "function") {
        return new AsyncFromSyncIterator(iterator.call(source));
    }
    throw new TypeError();
}
exports.GetAsyncIterator = GetAsyncIterator;
var AsyncFromSyncIterator = /** @class */ (function () {
    function AsyncFromSyncIterator(iterator) {
        this._iterator = iterator;
    }
    AsyncFromSyncIterator.prototype.next = function (value) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, done, resultValue, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _a = this._iterator.next(value), done = _a.done, resultValue = _a.value;
                        _b = { done: done };
                        return [4 /*yield*/, resultValue];
                    case 1: return [2 /*return*/, (_b.value = _c.sent(), _b)];
                }
            });
        });
    };
    AsyncFromSyncIterator.prototype.return = function (value) {
        return __awaiter(this, void 0, void 0, function () {
            var returnMethod, _a, done, resultValue, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        returnMethod = this._iterator.return;
                        if (returnMethod === undefined) {
                            return [2 /*return*/, { done: true, value: value }];
                        }
                        _a = returnMethod.call(this._iterator, value), done = _a.done, resultValue = _a.value;
                        _b = { done: done };
                        return [4 /*yield*/, resultValue];
                    case 1: return [2 /*return*/, (_b.value = _c.sent(), _b)];
                }
            });
        });
    };
    AsyncFromSyncIterator.prototype.throw = function (value) {
        return __awaiter(this, void 0, void 0, function () {
            var throwMethod, _a, done, resultValue, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        throwMethod = this._iterator.throw;
                        if (throwMethod === undefined) {
                            throw value;
                        }
                        _a = throwMethod.call(this._iterator, value), done = _a.done, resultValue = _a.value;
                        _b = { done: done };
                        return [4 /*yield*/, resultValue];
                    case 1: return [2 /*return*/, (_b.value = _c.sent(), _b)];
                }
            });
        });
    };
    AsyncFromSyncIterator = __decorate([
        decorators_1.ToStringTag("Async-from-sync Iterator")
    ], AsyncFromSyncIterator);
    return AsyncFromSyncIterator;
}());
/** @internal */
function GetHierarchy(value) {
    var hierarchy = value[types_1.Hierarchical.hierarchy];
    if (typeof hierarchy === "function") {
        return hierarchy.call(value);
    }
    throw new TypeError();
}
exports.GetHierarchy = GetHierarchy;
/** @internal */ function GetSource(query) {
    var sourceMethod = guards_1.IsQuerySource(query) ? query[types_2.QuerySource.source] : undefined;
    if (typeof sourceMethod === "function") {
        return sourceMethod.call(query);
    }
    return query;
}
exports.GetSource = GetSource;
/** @internal */ function GetAsyncSource(query) {
    var sourceMethod = guards_1.IsAsyncQuerySource(query) ? query[types_2.AsyncQuerySource.source] : undefined;
    if (typeof sourceMethod === "function") {
        return sourceMethod.call(query);
    }
    return query;
}
exports.GetAsyncSource = GetAsyncSource;
/** @internal */
function IteratorClose(iterator) {
    if (iterator !== undefined && iterator !== null) {
        var close = iterator.return;
        if (typeof close === "function") {
            return close.call(iterator);
        }
    }
}
exports.IteratorClose = IteratorClose;
/** @internal */
function AsyncIteratorClose(iterator) {
    if (iterator !== undefined && iterator !== null) {
        var close = iterator.return;
        if (typeof close === "function") {
            return close.call(iterator);
        }
    }
}
exports.AsyncIteratorClose = AsyncIteratorClose;
/** @internal */ function ThenBy(value, keySelector, comparison, descending) {
    var thenBy = value[types_1.OrderedIterable.thenBy];
    if (typeof thenBy === "function") {
        return thenBy.call(value, keySelector, comparison, descending);
    }
    throw new TypeError();
}
exports.ThenBy = ThenBy;
/** @internal */ function ThenByAsync(value, keySelector, comparison, descending) {
    var thenBy = value[types_1.AsyncOrderedIterable.thenByAsync];
    if (typeof thenBy === "function") {
        return thenBy.call(value, keySelector, comparison, descending);
    }
    throw new TypeError();
}
exports.ThenByAsync = ThenByAsync;
/** @internal */
function NextResult(value) {
    return { done: false, value: value };
}
exports.NextResult = NextResult;
/** @internal */
function DoneResult() {
    return { done: true, value: undefined };
}
exports.DoneResult = DoneResult;
/** @internal */
function SameValue(x, y) {
    return (x === y) ? (x !== 0 || 1 / x === 1 / y) : (x !== x && y !== y);
}
exports.SameValue = SameValue;
/** @internal */
function CreateGroupings(source, keySelector, elementSelector) {
    var e_1, _a;
    var map = new Map();
    try {
        for (var _b = __values(conversion_1.ToIterable(source)), _c = _b.next(); !_c.done; _c = _b.next()) {
            var item = _c.value;
            var key = keySelector(item);
            var element = elementSelector(item);
            var grouping = map.get(key);
            if (grouping == null) {
                grouping = [];
                map.set(key, grouping);
            }
            grouping.push(element);
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return map;
}
exports.CreateGroupings = CreateGroupings;
/** @internal */ function CreateGroupingsAsync(source, keySelector, elementSelector) {
    return __awaiter(this, void 0, void 0, function () {
        var e_2, _a, map, _b, _c, item, key, element, grouping, e_2_1;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    map = new Map();
                    _d.label = 1;
                case 1:
                    _d.trys.push([1, 7, 8, 13]);
                    _b = __asyncValues(conversion_1.ToPossiblyAsyncIterable(source));
                    _d.label = 2;
                case 2: return [4 /*yield*/, _b.next()];
                case 3:
                    if (!(_c = _d.sent(), !_c.done)) return [3 /*break*/, 6];
                    item = _c.value;
                    key = keySelector(item);
                    return [4 /*yield*/, elementSelector(item)];
                case 4:
                    element = _d.sent();
                    grouping = map.get(key);
                    if (grouping == null) {
                        grouping = [];
                        map.set(key, grouping);
                    }
                    grouping.push(element);
                    _d.label = 5;
                case 5: return [3 /*break*/, 2];
                case 6: return [3 /*break*/, 13];
                case 7:
                    e_2_1 = _d.sent();
                    e_2 = { error: e_2_1 };
                    return [3 /*break*/, 13];
                case 8:
                    _d.trys.push([8, , 11, 12]);
                    if (!(_c && !_c.done && (_a = _b.return))) return [3 /*break*/, 10];
                    return [4 /*yield*/, _a.call(_b)];
                case 9:
                    _d.sent();
                    _d.label = 10;
                case 10: return [3 /*break*/, 12];
                case 11:
                    if (e_2) throw e_2.error;
                    return [7 /*endfinally*/];
                case 12: return [7 /*endfinally*/];
                case 13: return [2 /*return*/, map];
            }
        });
    });
}
exports.CreateGroupingsAsync = CreateGroupingsAsync;
/** @internal */
function SelectGroupingKey(grouping) {
    return grouping[types_1.Grouping.key];
}
exports.SelectGroupingKey = SelectGroupingKey;
/** @internal */
function SelectValue(key) {
    return this[key];
}
exports.SelectValue = SelectValue;
/** @internal */
function SelectEntry(key) {
    return fn_1.tuple(key, this[key]);
}
exports.SelectEntry = SelectEntry;
